/*$$$ 
<filter id="saturationShader" label="Saturation" category="adjustment" vartype="intensity">
	<var varname="intensity" label="Intensity" type="number" numFactor="100" min="-1" max="1" default="0" />
</filter>
$$$*/

precision highp float;

uniform sampler2D tt_uniform_maintexture;

uniform float intensity;

varying vec2 mainTexCoord;

void main()
{
	vec4 dst;
	
	vec4 curCol;
	vec4 srcCol;
	
	float skinFactor;
	float curVal;
	float factor;
	
	srcCol = texture2D(tt_uniform_maintexture, mainTexCoord.xy);
	
	SHIFTCOMPS(srcCol)
	
	curCol = srcCol;
	
	skinFactor = 1.0 - max(curCol.r - (curCol.g+curCol.b)/2.0,0.0);
	skinFactor *= skinFactor;
	
	factor = step(0.0,-intensity);
	skinFactor = factor + skinFactor*(1.0-factor);
	
	float dIntens = -intensity;
	float intens = intensity + 1.0;
	
	mat3 satMatr = mat3(dIntens*0.299 + intens, dIntens*0.299, dIntens*0.299,
								dIntens*0.587, dIntens*0.587 + intens, dIntens*0.587,
								dIntens*0.114, dIntens*0.114, dIntens*0.114 + intens);
	
	
	curCol.rgb = satMatr * srcCol.rgb;
	
	dst.xyz = mix(srcCol.xyz,curCol.xyz,skinFactor);
	dst.xyz = min(dst.xyz,srcCol.w);
	dst.w = srcCol.w;
	
	SHIFTCOMPS(dst)
	
	gl_FragColor = dst;
}
